module Uranai
  class FittingParameter
    attr_reader :params
    alias :values :params

    def initialize(params)
      @params = params
    end

    def predict(input_data)
      check(input_data) do
        params
          .zip(input_data.insert(0, 1))
          .map { |n1,n2| n1 * n2 }
          .reduce(:+)
      end
    end

    private

    def check(data)
      raise "input data must be Array" unless data.kind_of?(Array)
      raise "input data size must be equal to feature size (#{feature_size})" if data.length != feature_size
      yield
    end

    def feature_size
      params.length - 1
    end
  end
end
